#include "global.h"
#include "buffer.h"

void Init_buffC(struct bufferC_struct *pBS)
{
	pBS->buffcnt=0;
	pBS->inpt=pBS->outpt=pBS->rbuff;
}

int put_buffC(struct bufferC_struct *pBS,unsigned char c)
{

    if (pBS->buffcnt<100)                        // If buffer not full
    {
        *(pBS->inpt) = c;                                // Put character into buffer
        pBS->inpt++;                                    // Increment pointer

        pBS->buffcnt++;

        if (pBS->inpt >= pBS->rbuff + 100)        // Pointer wrapping
            pBS->inpt = pBS->rbuff;
		return 1;
    }
	return 0;
}

int get_buffC(struct bufferC_struct *pBS)
{
    int byte;
    if (pBS->buffcnt==0)                        // If buffer empty
		return 0;


    byte = *(pBS->outpt);                                // Get byte
    pBS->outpt++;                                    // Increment pointer

    if (pBS->outpt >= pBS->rbuff + 100)            // Pointer wrapping
        pBS->outpt = pBS->rbuff;
    
    pBS->buffcnt--;                                    // Decrement buffer count

    return byte;
}


void Init_buffI(struct bufferI_struct *pBS)
{
	pBS->buffcnt=0;
	pBS->inpt=pBS->outpt=pBS->rbuff;
	pBS->alt=pBS->neu=0;
}

int put_buffI(struct bufferI_struct *pBS,int c)
{

    if (pBS->buffcnt<100)                        // If buffer not full
    {
        *(pBS->inpt) = c;                                // Put character into buffer
        pBS->inpt++;                                    // Increment pointer

        pBS->buffcnt++;

        if (pBS->inpt >= pBS->rbuff + 100)        // Pointer wrapping
            pBS->inpt = pBS->rbuff;
		return 1;
    }
	return 0;
}

int get_buffI(struct bufferI_struct *pBS)
{
    int byte;
    if (pBS->buffcnt==0)                        // If buffer empty
		return 0;


    byte = *(pBS->outpt);                                // Get byte
    pBS->outpt++;                                    // Increment pointer

    if (pBS->outpt >= pBS->rbuff + 100)            // Pointer wrapping
        pBS->outpt = pBS->rbuff;
    
    pBS->buffcnt--;                                    // Decrement buffer count

    return byte;
}

int get_buffI_filter(struct bufferI_struct *pBS)
{
	long ret=0;
	int i=0;
	int durchschnitt;
    if ((durchschnitt=pBS->buffcnt)==0)                        // If buffer empty
		return 0;

	for(i=0;i<=durchschnitt;i++)
		ret+=get_buffI(pBS);
	ret/=durchschnitt;
	pBS->alt=pBS->neu;
	pBS->neu=ret;
	return ret;
}
