#include "global.h"
#include "serial.h"
#include "interrupt.h"
#include "Timer.h"
#include "auswertung.h"
#include "ad.h"


void main() //Hauptprogramm
{
	_asm (" fclr i");
	InitSerial();
	InitTimer();
	InitInterrupt();
	InitAuswertung();
	InitAD();
	_asm (" fset i");

	//SendText("\01Kalibrierung ...");

	StartTimer();

	while((calBeschlX==0) || (calBeschlY==0))
	{
		if(bufX.buffcnt>10)
		{
			get_buffI(&bufX);
			calBeschlX=get_buffI(&bufX);
		}
		if(bufY.buffcnt>10)
		{
			get_buffI(&bufY);
			calBeschlY=get_buffI(&bufY);
		}
	}
	{
		char buf[10];
		sprintf(buf,"\04%d",calBeschlX);
		SendText(buf);
		sprintf(buf,"\16%d",calBeschlY);
		SendText(buf);
	}

	StopTimer();

	InitAuswertung();


	LCDausgabe=0;
	Auswert=0;

	StartAD();
	StartTimer();

	while(1)
	{
		if(Sende()==0)
			if(LCDausgabe>180)
			{
				ausgabe();
				LCDausgabe=0;
			}
	}	
}